import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.*;
import java.util.List;
import java.util.ArrayList;
/*
 * In this class we discuss exceptions with character streams
 */


public class ListWriter {
	private List<Integer> list;
	private static final int SIZE = 10;

	public ListWriter () {
		list = new ArrayList<Integer>(SIZE);
		for (int i = 0; i < SIZE; i++)
			list.add(new Integer(i));
	}
	public void writeList() {
		PrintWriter out = null;
		try {
			out = new PrintWriter(new FileWriter("myFile.txt"));
			for (int i = 0; i < SIZE; i++)
				out.println("Value at: " + i + " = " + list.get(i));
		} catch (IndexOutOfBoundsException e) {
			System.err.println("Caught IndexOutOfBoundsException: " +
					e.getMessage());
		} catch (IOException e) {
			System.err.println("Caught IOException: " + e.getMessage());
		} finally {
			if (out != null) {
				System.out.println("Closing PrintWriter");
				out.close();
			} else {
				System.out.println("PrintWriter not open");
			}
		}
	}

}
