import java.io.IOException;


public class ReThrowBeforeSE7 {

	public static void rethrowWrapping() {
		try {
			throw new IOException("It is a checked exception though!");
		}
		catch(IOException exception) {
			//Do some handling and then re-throw:
			throw new RuntimeException(exception);
		}
	}

	static class FirstException extends Exception {
		 
		public FirstException(String message) {
			super(message);
		} 
		}
	static class SecondException extends Exception {
		
		public SecondException(String message) {
			super(message);
		} 
	}

	public static void rethrowTwoChildren(String exceptionName) throws Exception {
		try {
			if (exceptionName.equals("First")) {
				throw new FirstException("It is First Exception");
			} else {
				throw new SecondException("It is SecondException");
			}
		} catch (Exception e) {
			throw e;
		}
	}

	public static void main( String[] args )   {
		try {
			rethrowWrapping();
		}
		catch(RuntimeException exception) {
			//here I need to get the cause as I wrapped
			System.err.println(exception.getCause().getMessage());
		}
		try {
			rethrowTwoChildren("First");
		}
		catch(Exception ex) {
			//here the cause is clear as inheritance applies, but the developer does not know which children.
			//Before Java SE7, I could not include a throws of a child 
			//from the main signature
			System.err.println(ex.getMessage());
		}
	}
}
